-- 
-- specialization for visibility of parts Lanz
-- 07/09/13
-- author: schwaki
-- basierend auf dem Scripts EicherEM300Animations.lua von Modelleicher
--

Anbauteile = {};

function Anbauteile.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Motorized, specializations);
end;

function Anbauteile:load(xmlFile)
	self.changeDachState = Anbauteile.changeDachState; -- self:changeDachState(state, noEventSend)
	
	-- Dach ein / ausblenden
	self.Dach = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.Anbauteile.Dach#index"));
	self.DachState = Utils.getNoNil(getXMLBool(xmlFile, "vehicle.Anbauteile.Dach#startState"), true);
	
end;

function Anbauteile:readStream(streamId, connection)  
     self:changeDachState(streamReadBool(streamId), true);  
end;

function Anbauteile:writeStream(streamId, connection)  
    streamWriteBool(streamId, self.DachState);  
end;

function Anbauteile:delete()
end;

function Anbauteile:mouseEvent(posX, posY, isDown, isUp, button)
end;

function Anbauteile:keyEvent(unicode, sym, modifier, isDown)
end;

function Anbauteile:changeDachState(state, noEventSend)
	changeDachStateEvent.sendEvent(self, state, noEventSend);
	self.DachState = state;
	setVisibility(self.Dach, state);
end;

function Anbauteile:updateTick(dt)
end;


function Anbauteile:update(dt)
	if self:getIsActiveForInput() then
		if InputBinding.hasEvent(InputBinding.Anbauteile) then
			self:changeDachState(not self.DachState);
		end;
	end;

end;

function Anbauteile:draw()
	if self.DachState then
		g_currentMission:addHelpButtonText(g_i18n:getText("Anbauteile_off"), InputBinding.Anbauteile);
	else
		g_currentMission:addHelpButtonText(g_i18n:getText("Anbauteile_on"), InputBinding.Anbauteile);
	end;
end;

function Anbauteile:onEnter()
end;

function Anbauteile:onLeave()
end;

function Anbauteile:loadFromAttributesAndNodes(xmlFile, key, resetVehicles)
	if not resetVehicles then
		local state = Utils.getNoNil(getXMLBool(xmlFile, key.."#DachState"));
		self:changeDachState(state);
	end;
	return BaseMission.VEHICLE_LOAD_OK;
end;

function Anbauteile:getSaveAttributesAndNodes(nodeIdent)
	local attributes = 'DachState="'..tostring(self.DachState)..'"';
	local nodes = nil;
	return attributes,nodes;
end;



changeDachStateEvent = {};
changeDachStateEvent_mt = Class(changeDachStateEvent, Event);
InitEventClass(changeDachStateEvent, "changeDachStateEvent");

function changeDachStateEvent:emptyNew()  
    local self = Event:new(changeDachStateEvent_mt );
    self.className="changeDachStateEvent";
    return self;
end;

function changeDachStateEvent:new(vehicle, state) 
    self.vehicle = vehicle;
    self.state = state;
    return self;
end;

function changeDachStateEvent:readStream(streamId, connection)  
    local id = streamReadInt32(streamId); 
    self.state = streamReadBool(streamId); 
    self.vehicle = networkGetObject(id); 
    self:run(connection);  
end;

function changeDachStateEvent:writeStream(streamId, connection)   
    streamWriteInt32(streamId, networkGetObjectId(self.vehicle));	
    streamWriteBool(streamId, self.state );   
end;

function changeDachStateEvent:run(connection) 
    self.vehicle:changeDachState(self.state, true);
	if not connection:getIsServer() then  
		g_server:broadcastEvent(changeDachStateEvent:new(self.vehicle, self.state), nil, connection, self.object);
	end;
end;

function changeDachStateEvent.sendEvent(vehicle, state, noEventSend)  
	if noEventSend == nil or noEventSend == false then
		if g_server ~= nil then   
			g_server:broadcastEvent(changeDachStateEvent:new(vehicle, state), nil, nil, vehicle);
		else 
			g_client:getServerConnection():sendEvent(changeDachStateEvent:new(vehicle, state));
		end;
	end;
end;